<template>
  <div ref="matched-component" id="matched-component">
    <v-icon id="close-icon" @click="close">mdi-close</v-icon>
    <div class="column">
      <h3 class="header">Lubicie się ;)</h3>
      <div class="row">
        <div :class="{'person-wrapper': true, left: true, 'is-small': !isLargeScreen}">
          <Person
            :data="{
              nick: $store.state.user.nick,
              image: $store.state.user.photos.profile,
            }"
          />
        </div>
        <div :class="{'person-wrapper': true, right: true, 'is-small': !isLargeScreen}">
          <Person :data="person" />
        </div>
      </div>
      <div id="input-component-wrapper">
        <InputComponent @content="
                (data) => {
                  setContent(data);
                }
              "/>
        <v-icon
          @click="sendMessage"
          style="z-index: 1000; cursor: pointer; transform: translate(62vw, -94px);"
        >
          mdi-send
        </v-icon>
      </div>
    </div>
  </div>
</template>
<script>
import { useMediaQuery } from "@vueuse/core";
const isLargeScreen = useMediaQuery("(min-width: 750px)");
import InputComponent from "./InputComponent.vue";
import Person from "./Person.vue";

export default {
  name: "MatchedComponent",
  component: { Person, InputComponent },
  props: {
    person: {
      type: Object,
      required: true,
    },
  },
  data(){
    return {
      content: '',
      isLargeScreen: null
    }
  },
  mounted() {
    this.isLargeScreen = isLargeScreen;
  },
  methods: {
    close() {
      this.$refs["matched-component"].classList.add("close");
      setTimeout(() => {
        this.$emit("close");
      }, 1000);
    },
    setContent(data) {
      this.content = data;
    },
    sendMessage() {
      if(this.content==='') {
        return;
      }
      this.$store.state.ws.send(
        JSON.stringify({
          message: {
            [this.person.nick]: JSON.stringify({
              datetime: new Date().toISOString().slice(0, 19).replace('T', ' '),
              nick: this.person.nick,
              content: this.content,
            }),
            from: this.$store.state.user.uuid,
          },
        })
      );
      this.setContent('');
      this.$bus.$emit('clear-input');
    },
  },
};
</script>
<style lang="scss" scoped>
#matched-component {
  display: flex;
  flex-direction: row;
  position: fixed;
  align-items: center;
  justify-content: center;
  width: 100vw;
  height: 100vh;
  top: 0px;
  left: 0px;
  color: rgba(255, 255, 255, 1);

  z-index: 9999;
  background: rgba(25, 25, 25, 0.85);
  &.close {
    transform: scale(0);
    transition: 1s;
    animation-duration: 1s;
    animation-name: close;
    animation-fill-mode: forwards;
    animation-iteration-count: 1;
  }
  #close-icon {
    position: absolute;
    right: 40px;
    top: 40px;
    color: rgba(255, 255, 255, 1);
  }
  .column {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100vw;
    .row {
      display: flex;
      flex-direction: row;
      justify-content: center;
    }
    .header {
      position: absolute;
      top: 27px;
      left: calc(50vw - 49px);
      color: rgba(255, 255, 255, 1);
    }
    .person-wrapper {
      width: 27%;
      height: auto;
      max-height: 295px;
      margin: 64px;
      &.is-small {
        width: 20%;
      }
      &.left {
        position: relative;
        animation-duration: 2s;
        animation-name: left;
        animation-fill-mode: forwards;
        animation-iteration-count: 1;
      }

      &.right {
        position: relative;
        animation-duration: 2s;
        animation-name: right;
        animation-fill-mode: forwards;
        animation-iteration-count: 1;
      }
    }

    #input-component-wrapper {
      transform: translateX(-4px);
      margin: 60px 21px auto;
      width: 67.4%;
      height: 67px;
      overflow: hidden;
      line-height: 50px;
      color: rgba(30, 30, 30, 0.7);
    }
  }
}

@keyframes left {
  from {
    position: absolute;
    left: -1000px;
  }

  to {
    left: 0px;
  }
}

@keyframes right {
  from {
    position: relative;
    left: 1000px;
  }

  to {
    left: 0px;
  }
}
@keyframes close {
  from {
    opacity: 1;
  }
  to {
    opacity: 0;
  }
}
</style>
